/*
 * py_calldist.d - measure Python elapsed times for functions.
 *                 Written for the Python DTrace provider.
 *
 * $Id: py_calldist.d 28 2007-09-13 10:49:37Z brendan $
 *
 * This traces Python activity from all programs running on the system with
 * Python provider support.
 *
 * This script prints distribution plots of elapsed time for Python
 * operations. Use py_calltime.d for summary reports.
 *
 * FIELDS:
 *		1		Filename of the Python program
 *		2		Name of call
 *
 * Filename and function names are printed if available.
 *
 * COPYRIGHT: Copyright (c) 2007 Brendan Gregg.
 *
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 *
 * 09-Sep-2007	Brendan Gregg	Created this.
 * 16-Dec-2008	Tom Erickson	(adapted for Chime)
 */

/*
 * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
 */

python*:::function-entry
{
	self->depth++;
	self->function[self->depth] = ??TIMESTAMP??;
}

python*:::function-return
/self->function[self->depth]/
{
	this->elapsed = ??TIMESTAMP?? - self->function[self->depth];
	self->function[self->depth] = 0;
	this->file = basename(copyinstr(arg0));
	this->name = copyinstr(arg1);

	@types[this->file, this->name] =
	    quantize(this->elapsed / 1000);

	self->depth--;
}

??TIMESTAMP timestamp
